/*
 * File:  SeqCounter.hh
 * Author:  mikolas
 * Created on:  Thu Dec 1 15:53:16 GMTST 2011
 * Copyright (C) 2011, Mikolas Janota
 */
#ifndef SEQCOUNTER_HH_25162
#define SEQCOUNTER_HH_25162
#define SEQCOUNTER_DBG(t)
#include <vector>
#include "MiniSatExt.h"
using std::vector;
using SATSPC::Lit;
using SATSPC::mkLit;
using SATSPC::Var;
using SATSPC::vec;
using SATSPC::MiniSatExt;

class SeqCounter {
public:
  SeqCounter(size_t tval,
          MiniSatExt& solver,
          const vector<Var>& inputs)
  : tval(tval)
  , solver(solver)
  , inputs(inputs)
  {
    for (size_t i=0; i<(inputs.size()-1)*tval; ++i)
        aux.push_back(newv());
  }

  void                 encode();
  void                 encode_all0();
private:
  const size_t         tval;
  MiniSatExt&          solver;
  const vector<Var>&   inputs;
  vector<Var>          aux;

  Var newv(){ return solver.newVar(); }

  inline Var s(size_t v_index, size_t j) { 
    assert(v_index>0);
    assert(v_index<inputs.size());
    assert(j>=1);
    assert(j<=tval);
    return aux[(v_index-1)*tval + j-1];
  }

  inline Var v(size_t v_index) { 
    assert(v_index>0);
    assert(v_index<=inputs.size());
    return inputs[v_index-1];
   }
};

#endif /* SEQCOUNTER_HH_25162 */
