/*
 * File:  parse_num.cpp
 * Author:  mikolas
 * Created on:  Mon Sep 4 15:46:54 WEST 2017
 * Copyright (C) 2017, Mikolas Janota
 */
#include<limits.h>
#include"auxiliary.h"
#include"ReadException.h"
#include"parse_num.h"
#include<locale.h>
int parse_nonneg_int(const string& s) {
    const int M = INT_MAX;
    unsigned long res = 0;
    if (s.empty()) throw ReadException("given  an empty string instead of a number");
    for (char c : s) {
        if (!isdigit(c)) throw ReadException("'" + s + "' is expected to be a nonnegative number");
        res = res * 10 + (c - '0');
        if (res > M)  throw ReadException("'" + s + "' appears to be too large");
    }
    //std::cerr<<"c PARSING: '"<<s<<"' -> "<<res<<std::endl;
    return (int) res;
}
