/*
 * File:  proximity_table.h
 * Author:  mikolas
 * Created on:  14 Mar 2017 09:36:36
 * Copyright (C) 2017, Mikolas Janota
 */
#ifndef PROXIMITY_TABLE_H_13543
#define PROXIMITY_TABLE_H_13543
#include "LevelInfo.h"
#include "proximity.h"
#include <vector>
#include <unordered_map>
using std::make_pair;
using std::unordered_map;
using std::vector;
class ProximityTable {
    public:
        typedef std::pair<Var, float> Val;
        typedef std::unordered_map<Var, std::vector<Val>* > Table;
        ProximityTable() {}
        void operator () (const Proximity& proximity, const LevelInfo& level_info);
        virtual ~ProximityTable();
        const Table& table() const { return m_table; }
    protected:
        Table m_table;
};
#endif /* PROXIMITY_TABLE_H_13543 */
